// This file was generated by createCFunction.sci on 10-09-2016 01:18

// Computational function for X2C block Selector

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <Selector_Float32.h>
#include <Selector_Float32.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_Selector_Float32_C(scicos_block* block, scicos_flag flag);
static void x2c_Selector_Float32_C__OutputUpdate(scicos_block* block);
static void x2c_Selector_Float32_C__StateUpdate(scicos_block* block);
static void x2c_Selector_Float32_C__Initialization(scicos_block* block);
static void x2c_Selector_Float32_C__Ending(scicos_block* block);


void x2c_Selector_Float32_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_Selector_Float32_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_Selector_Float32_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_Selector_Float32_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_Selector_Float32_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_Selector_Float32_C__set_parameter(scicos_block* block, SELECTOR_FLOAT32 *blockParam) {
    int *paramI;
    double *paramR;
    SELECTOR_FLOAT32 *pTSelector_Float32;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTSelector_Float32 = GetWorkPtrs(block);
}


static void x2c_Selector_Float32_C__Initialization(scicos_block* block) {
    SELECTOR_FLOAT32 *pTSelector_Float32;

    /* Declaration of inports */
    double *inport_In0_p;
    float32 inport_In0;
    double *inport_In1_p;
    float32 inport_In1;
    double *inport_In2_p;
    float32 inport_In2;
    double *inport_In3_p;
    float32 inport_In3;
    double *inport_In4_p;
    float32 inport_In4;
    double *inport_In5_p;
    float32 inport_In5;
    double *inport_In6_p;
    float32 inport_In6;
    double *inport_In7_p;
    float32 inport_In7;
    double *inport_Select_p;
    int8 inport_Select;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTSelector_Float32 = scicos_malloc(sizeof(SELECTOR_FLOAT32));
    GetWorkPtrs(block) = pTSelector_Float32;
    x2c_Selector_Float32_C__set_parameter(block, pTSelector_Float32);

    /* Assignment of inports */
    inport_In0_p = GetInPortPtrs(block, 1);
    inport_In0 = convert_double_to_float32(*inport_In0_p);
    pTSelector_Float32->In0 = &inport_In0;
    inport_In1_p = GetInPortPtrs(block, 2);
    inport_In1 = convert_double_to_float32(*inport_In1_p);
    pTSelector_Float32->In1 = &inport_In1;
    inport_In2_p = GetInPortPtrs(block, 3);
    inport_In2 = convert_double_to_float32(*inport_In2_p);
    pTSelector_Float32->In2 = &inport_In2;
    inport_In3_p = GetInPortPtrs(block, 4);
    inport_In3 = convert_double_to_float32(*inport_In3_p);
    pTSelector_Float32->In3 = &inport_In3;
    inport_In4_p = GetInPortPtrs(block, 5);
    inport_In4 = convert_double_to_float32(*inport_In4_p);
    pTSelector_Float32->In4 = &inport_In4;
    inport_In5_p = GetInPortPtrs(block, 6);
    inport_In5 = convert_double_to_float32(*inport_In5_p);
    pTSelector_Float32->In5 = &inport_In5;
    inport_In6_p = GetInPortPtrs(block, 7);
    inport_In6 = convert_double_to_float32(*inport_In6_p);
    pTSelector_Float32->In6 = &inport_In6;
    inport_In7_p = GetInPortPtrs(block, 8);
    inport_In7 = convert_double_to_float32(*inport_In7_p);
    pTSelector_Float32->In7 = &inport_In7;
    inport_Select_p = GetInPortPtrs(block, 9);
    inport_Select = convert_double_to_Q7(*inport_Select_p);
    pTSelector_Float32->Select = &inport_Select;

    /* Assignment of parameter arrays */

    /* Initialization */
    Selector_Float32_Init(pTSelector_Float32);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = convert_float32_to_double(pTSelector_Float32->Out);
}


static void x2c_Selector_Float32_C__Ending(scicos_block* block) {
    SELECTOR_FLOAT32 *pTSelector_Float32;
    pTSelector_Float32 = GetWorkPtrs(block);
    scicos_free(pTSelector_Float32);
}


static void x2c_Selector_Float32_C__StateUpdate_f(scicos_block* block) {
/* Do nothing, calling of update function and writing to outputs is done in OutputUpdate */
}


static void x2c_Selector_Float32_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_Selector_Float32_C__StateUpdate_f(block);
    }
}


static void x2c_Selector_Float32_C__OutputUpdate(scicos_block* block) {
    SELECTOR_FLOAT32 *pTSelector_Float32;

    /* Declaration of inports */
    double *inport_In0_p;
    float32 inport_In0;
    double *inport_In1_p;
    float32 inport_In1;
    double *inport_In2_p;
    float32 inport_In2;
    double *inport_In3_p;
    float32 inport_In3;
    double *inport_In4_p;
    float32 inport_In4;
    double *inport_In5_p;
    float32 inport_In5;
    double *inport_In6_p;
    float32 inport_In6;
    double *inport_In7_p;
    float32 inport_In7;
    double *inport_Select_p;
    int8 inport_Select;

    /* Declaration of outports */
    double *outport_Out;

    /* *** */
    pTSelector_Float32 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_In0_p = GetInPortPtrs(block, 1);
    inport_In0 = convert_double_to_float32(*inport_In0_p);
    pTSelector_Float32->In0 = &inport_In0;
    inport_In1_p = GetInPortPtrs(block, 2);
    inport_In1 = convert_double_to_float32(*inport_In1_p);
    pTSelector_Float32->In1 = &inport_In1;
    inport_In2_p = GetInPortPtrs(block, 3);
    inport_In2 = convert_double_to_float32(*inport_In2_p);
    pTSelector_Float32->In2 = &inport_In2;
    inport_In3_p = GetInPortPtrs(block, 4);
    inport_In3 = convert_double_to_float32(*inport_In3_p);
    pTSelector_Float32->In3 = &inport_In3;
    inport_In4_p = GetInPortPtrs(block, 5);
    inport_In4 = convert_double_to_float32(*inport_In4_p);
    pTSelector_Float32->In4 = &inport_In4;
    inport_In5_p = GetInPortPtrs(block, 6);
    inport_In5 = convert_double_to_float32(*inport_In5_p);
    pTSelector_Float32->In5 = &inport_In5;
    inport_In6_p = GetInPortPtrs(block, 7);
    inport_In6 = convert_double_to_float32(*inport_In6_p);
    pTSelector_Float32->In6 = &inport_In6;
    inport_In7_p = GetInPortPtrs(block, 8);
    inport_In7 = convert_double_to_float32(*inport_In7_p);
    pTSelector_Float32->In7 = &inport_In7;
    inport_Select_p = GetInPortPtrs(block, 9);
    inport_Select = convert_double_to_Q7(*inport_Select_p);
    pTSelector_Float32->Select = &inport_Select;

    /* Assignment of parameter arrays */

    /* Update */
    Selector_Float32_Update(pTSelector_Float32);

    /* Assignment of outports */
    outport_Out = GetOutPortPtrs(block, 1);
    *outport_Out = convert_float32_to_double(pTSelector_Float32->Out);
}


