// This file was generated by createCFunction.sci on 10-09-2016 01:18

// Computational function for X2C block Sequencer

#define SCILAB_SIM_FILE /* mark this file as Scilab simulation file */

/* include Scicos / Xcos headers */
#include <scicos.h>
#include <scicos_block4.h>
#include <scicos_malloc.h>
#include <scicos_free.h>
#include <Simulation_PortConversion.h>
//#define DEBUG // uncomment to enable debugging
#ifdef DEBUG
    #include <stdio.h>
#endif

/* include block implementation */
#include <Sequencer_FiP16.h>
#include <Sequencer_FiP16.c>

/* */
#define BLOCK_ERROR_INPUT_OUT_OF_DOMAIN (-1)
#define BLOCK_ERROR_SINGULARITY (-2)
#define BLOCK_ERROR_INTERNAL (-3)
#define BLOCK_ERROR_CANNOT_ALLOCATE_MEMORY (-16)

/* */
void x2c_Sequencer_FiP16_C(scicos_block* block, scicos_flag flag);
static void x2c_Sequencer_FiP16_C__OutputUpdate(scicos_block* block);
static void x2c_Sequencer_FiP16_C__StateUpdate(scicos_block* block);
static void x2c_Sequencer_FiP16_C__Initialization(scicos_block* block);
static void x2c_Sequencer_FiP16_C__Ending(scicos_block* block);


void x2c_Sequencer_FiP16_C(scicos_block* block, scicos_flag flag) {
    /*
     * This function will be called by Xcos
     */
    switch (flag) {
        case DerivativeState:  /* 0 */
        {
            break;
        }
        case OutputUpdate:     /* 1 */
        {
            x2c_Sequencer_FiP16_C__OutputUpdate(block);
            break;
        }
        case StateUpdate:      /* 2 */
        {
            x2c_Sequencer_FiP16_C__StateUpdate(block);
            break;
        }
        case OutputEventTiming: /* 3 */
        {
            break;
        }
        case Initialization:   /* 4 */
        {
            x2c_Sequencer_FiP16_C__Initialization(block);
            break;
        }
        case Ending:           /* 5 */
        {
            x2c_Sequencer_FiP16_C__Ending(block);
            break;
        }
        case ReInitialization: /* 6 */
        {
            break;
        }
        case ContinousPropertiesUpdate: /* 7 */
        {
            break;
        }
        case ZeroCrossing:     /* 9 */
        {
           break;
        }
        default:     /* Jacobian (v5.5.0) or Residute (v5.4.1) or something else */
        {
           break;
        }
    }
}


static void x2c_Sequencer_FiP16_C__set_parameter(scicos_block* block, SEQUENCER_FIP16 *blockParam) {
    int *paramI;
    double *paramR;
    SEQUENCER_FIP16 *pTSequencer_FiP16;
    
    /* *** */
    paramI = GetIparPtrs(block);  /* integer parameters  */
    paramR = GetRparPtrs(block);  /* real parameters     */
    pTSequencer_FiP16 = GetWorkPtrs(block);
    blockParam->delay1 = (uint16)paramI[0];
    blockParam->delay2 = (uint16)paramI[1];
    blockParam->delay3 = (uint16)paramI[2];
    blockParam->delay4 = (uint16)paramI[3];
}


static void x2c_Sequencer_FiP16_C__Initialization(scicos_block* block) {
    SEQUENCER_FIP16 *pTSequencer_FiP16;

    /* Declaration of inports */
    double *inport_Start_p;
    int16 inport_Start;

    /* Declaration of outports */
    double *outport_Out1;
    double *outport_Out2;
    double *outport_Out3;
    double *outport_Out4;

    /* *** */
    pTSequencer_FiP16 = scicos_malloc(sizeof(SEQUENCER_FIP16));
    GetWorkPtrs(block) = pTSequencer_FiP16;
    x2c_Sequencer_FiP16_C__set_parameter(block, pTSequencer_FiP16);

    /* Assignment of inports */
    inport_Start_p = GetInPortPtrs(block, 1);
    inport_Start = convert_double_to_Q15(*inport_Start_p);
    pTSequencer_FiP16->Start = &inport_Start;

    /* Assignment of parameter arrays */

    /* Initialization */
    Sequencer_FiP16_Init(pTSequencer_FiP16);

    /* Assignment of outports */
    outport_Out1 = GetOutPortPtrs(block, 1);
    *outport_Out1 = convert_Q15_to_double(pTSequencer_FiP16->Out1);
    outport_Out2 = GetOutPortPtrs(block, 2);
    *outport_Out2 = convert_Q15_to_double(pTSequencer_FiP16->Out2);
    outport_Out3 = GetOutPortPtrs(block, 3);
    *outport_Out3 = convert_Q15_to_double(pTSequencer_FiP16->Out3);
    outport_Out4 = GetOutPortPtrs(block, 4);
    *outport_Out4 = convert_Q15_to_double(pTSequencer_FiP16->Out4);
}


static void x2c_Sequencer_FiP16_C__Ending(scicos_block* block) {
    SEQUENCER_FIP16 *pTSequencer_FiP16;
    pTSequencer_FiP16 = GetWorkPtrs(block);
    scicos_free(pTSequencer_FiP16);
}


static void x2c_Sequencer_FiP16_C__StateUpdate_f(scicos_block* block) {
/* Do nothing, calling of update function and writing to outputs is done in OutputUpdate */
}


static void x2c_Sequencer_FiP16_C__StateUpdate(scicos_block* block) {
    if (GetNevIn(block) > 0) {
        /*
        * GetNevIn(block) returns -1 in case this function was called due to an internal zero-crossing.
        * GetNevIn(block)  ... activation index
        */
        x2c_Sequencer_FiP16_C__StateUpdate_f(block);
    }
}


static void x2c_Sequencer_FiP16_C__OutputUpdate(scicos_block* block) {
    SEQUENCER_FIP16 *pTSequencer_FiP16;

    /* Declaration of inports */
    double *inport_Start_p;
    int16 inport_Start;

    /* Declaration of outports */
    double *outport_Out1;
    double *outport_Out2;
    double *outport_Out3;
    double *outport_Out4;

    /* *** */
    pTSequencer_FiP16 = GetWorkPtrs(block);

    /* Assignment of inports */
    inport_Start_p = GetInPortPtrs(block, 1);
    inport_Start = convert_double_to_Q15(*inport_Start_p);
    pTSequencer_FiP16->Start = &inport_Start;

    /* Assignment of parameter arrays */

    /* Update */
    Sequencer_FiP16_Update(pTSequencer_FiP16);

    /* Assignment of outports */
    outport_Out1 = GetOutPortPtrs(block, 1);
    *outport_Out1 = convert_Q15_to_double(pTSequencer_FiP16->Out1);
    outport_Out2 = GetOutPortPtrs(block, 2);
    *outport_Out2 = convert_Q15_to_double(pTSequencer_FiP16->Out2);
    outport_Out3 = GetOutPortPtrs(block, 3);
    *outport_Out3 = convert_Q15_to_double(pTSequencer_FiP16->Out3);
    outport_Out4 = GetOutPortPtrs(block, 4);
    *outport_Out4 = convert_Q15_to_double(pTSequencer_FiP16->Out4);
}


